#include "batch.h"
#include "module.h"
#include "wuch.h"

/** upgrade or install pacakges in batch mode.
 * \param list array of packages names to bu upgrated
 * \param count count of packages names stored in list prameter
 */
int batch_run(char *srcdir,char *destdir,char ** list, int count, int action)
{
	struct rpmmen_cb cb={
		NULL,
		NULL,
		NULL,
		NULL,
		batchcb_conflict,
		NULL
		};
	int status;
	TPkgSet *pkgs;
	TPkgInfo *pk;
	int i;
	printf("Welcome in batch mode.\n");
	if(action != MODE_BATCH && action != MODE_CHECK_DEPS){
		printf("ERROR: no submode (-b or -D option)\n");
		exit(1);
	}
	printf("submode is: %s \n",action == MODE_BATCH ? 
			"batch installing (test)" :
			"distributions dep's check");
	
//	setvbuf(stdout,NULL,_IONBF,0);
	status=rpmpldi_init(srcdir,destdir,&cb);
	switch(status){
		case 0:
			log_message("RPM base opened");
			break;
		case 1:
			log_message("Can't create directory for rpm's base");
			printf(_("Can't create directory for rpm's base\n"));
			return 1;
			break;
		case 2: 
			log_message("Can't open RPM's base");
			printf(_("Can't open RPM's base\n"));
			return 1;
			break;
	}
	
	printf(_("loading tocfile.\n"));
	if(rpmpldi_scandir()){
		log_message("Can't get list of pacakges from src media");
		printf(_("Can't get list of pacakges from src media\n"));
		rpmpldi_finish();
		return 1;
	}
	printf(_("done\n"));

	printf(_("sorting packages list."));
	pkgs=rpmpldi_getPkgsSet();
	n_array_sort(pkgs->packages);
	printf(_("done\nselectiong packages\n"));
        switch (action){
                case MODE_BATCH:
                        rpmpldi_selectpackages(list,count);
                        break;
                case MODE_CHECK_DEPS:
                        /* It selects all posible packages from the list of
			 * packages readed from tocfile. In order to make
			 * rpmpldi_add_deps(); on this list.*/
                        for (i=0;i<pkgs_array_num(pkgs);i++){
                                pkgs_array_nth(pkgs,i)->selected=
					RPMMEN_FROM_FILE;
                                pkgs_array_nth(pkgs,i)->installedEVR=NULL;
                        }
        }

	printf(_("done\nadding deps\n"));
	rpmpldi_add_deps();
/* TODO print/save list of selected packages (use code from pkgssel ?) */
	if (action == MODE_CHECK_DEPS) exit (0);
	for(i=0;i<pkgs_array_num(pkgs);i++){
		pk=pkgs_array_nth(pkgs,i);
		if(pk->selected){
			if(pk->flags&(TPKGINF_UPGRADE|
						TPKGINF_EQUAL|
						TPKGINF_OLDER)){
				printf("U ");
			}else{
				printf("i ");
			}
			printf("%s\n",pk->fname);
		}
	}
	rpmpldi_finish();
	return 0;
}
char *batch_mkstrNVRF(char *name,char *ver,char *rel,int flag)
{
    static char ret[100];

    strcpy(ret,name);
    if(ver&&strlen(ver)){
        strcat(ret," (");
        if(flag&RPMSENSE_LESS)
            strcat(ret,"<");
        if(flag&RPMSENSE_EQUAL)
            strcat(ret,"=");
        if(flag&RPMSENSE_GREATER)
            strcat(ret,">");
        strcat(ret,ver);
        if(rel){
            strcat(ret,"-");
            strcat(ret,rel);
        }
        strcat(ret,")");
    }
    return ret;
}

int batchcb_conflict(int action,char *name1,char *ver1,char *rel1,
                char *name2,char *ver2,int flag2)
{
        static char  *ctext=NULL,*utext=NULL;
        char uhead[]="\n\nPackages listed below requires some features which are \
        not provided by any other package.\n";
        char chead[]="Pacakges listed below can't be instaled simultaneously.\n";
        char *text;
        int size;

        switch(action){
                case RPMMEN_CB_CONFLICT_ADD:
                        if(!ctext)
                                ctext=strdup("");
                        ctext=(char *)realloc(ctext,strlen(ctext)+1+
                                        strlen(name1)+strlen(name2)+80);
                        strcat(ctext,"\n");
                        strcat(ctext,batch_mkstrNVRF(name1,ver1,rel1,0));
                        strcat(ctext,"  <--->  ");
                        strcat(ctext,batch_mkstrNVRF(name2,ver2,NULL,flag2));
                        break;
                case RPMMEN_CB_CONFLICT_UNSATISFIED:
                        if(!utext)
                                utext=strdup("");
                        utext=(char *)realloc(utext,strlen(utext)+1+
                                        strlen(name1)+strlen(name2)+80);
                        strcat(utext,"\npackage ");
                        strcat(utext,batch_mkstrNVRF(name1,ver1,rel1,0));
                        strcat(utext,"  requires ");
                        strcat(utext,batch_mkstrNVRF(name2,ver2,NULL,flag2));
                        break;
                case RPMMEN_CB_CONFLICT_NEW:
                        if(ctext)
                                free(ctext);
                        ctext=NULL;
                        if(utext)
                                free(utext);
                        utext=NULL;

                        break;
                case RPMMEN_CB_CONFLICT_SHOW:
                        if((!ctext) && (!utext))
                                return 0;
                        printf("%s","Dependencies problems");
                        size=0;
                        if(ctext)
                                size+=strlen(ctext)+strlen(chead);
                        if(utext)
                                size+=strlen(utext)+strlen(uhead);
                        text=(char *)malloc(size+10);
                        strcpy(text,"");
                        if(ctext){
                                strcat(text,chead);
                                strcat(text,ctext);
                        }
                        if(utext){
                                strcat(text,uhead);
                                strcat(text,utext);
                        }
                        printf(text);
                        break;
                        return 1;
        }
        return 0; /* if function return heare returned value is _not_ 
                     important */
}

/* module entry point */
void batch_ui(struct module_context *ctx)
{
	batch_run("", (char*)ctx->root, ctx->upgrade_list, 
		  ctx->upgrade_count, ctx->mode);
	/* TODO free upgradeList */
	/* ?? --mal */
}
